# Clapte #

**内容**  
1. Clapteの概要  
2. ライセンス  
3. 動作環境  
4. インストールとアンインストール  
5. 特殊な機能  
6. その他  
7. 更新履歴  

---
## 1. Clapteの概要 ##

Clapteは、数式中の単位や有効数値を考慮できる常駐型の数式電卓です。

Clapteには、以下のような機能があります。

### 常駐クリップボード計算 ###

Clapteを起動した状態で、数式として認識可能な文字列をクリップボードにコピーすると、自動的に計算を実行してその結果をバルーン表示します。

続けて、

* バルーンをクリックする。
* 同じ数式をコピーする。
* ホットキーを押す。

のいずれかを実行することで、計算結果をクリップボードにコピーすることができます。

また、カンマや空白、スペース等で区切られた数値をクリップボードにコピーした際には、
それらの数値の個数、総和、最大値、最小値、及び平均をバルーン表示します。

### 2分割メモ帳形式の計算機 ###

Clapteのタスクトレイアイコンをダブルクリックするか、Clapteを多重起動することで、計算機を起動できます。

計算機の左側ペインに計算式や方程式を入力すると、自動的に計算が実行され、計算結果が対応する右側ペインに表示されます。

計算機では、単純な計算機能に加え、以下のような機能を利用することが出来ます。

* 定数、関数の定義と利用
* 連立方程式の求解
* 数式の変形（展開、整理、因数分解）


---
## 2. ライセンス ##

Clapte は MIT License で配布されます。
```
MIT license  
Copyright(c) 2016-2019 GoodSeat
[https://sites.google.com/site/eatbaconandham/clapte/license]
```

MIT Licenseでは、以下の2点に同意いただければ、目的を問わず自由に利用してかまいません。

1. 著作権表示および本許諾表示をソフトウェアのすべての複製または重要な部分に記載しなければならない。
2. 作者または著作権者は、ソフトウェアに関して何ら責任を負わない。


なお、Clapteでは以下のライブラリを使用しています。 
配布の際には以下の著作権表示も含めるようにご留意ください。

#### Azuki[http://sgry.b.osdn.me/] ####
```
zlib license  
Copyright(c) 2008-2013 Suguru YAMAMOTO
[https://opensource.org/licenses/Zlib]
```

---
## 3. 動作環境 ##

 動作には .NetFramework 4.0 が必要です。


---
## 4. インストールとアンインストール ##

* インストール  

    Clapteフォルダを適当なディレクトリに配置してください。

* アンインストール  

    レジストリは使用していませんので、単にClapteフォルダを丸ごと削除してください。


---
## 5. 特殊な機能 ##

* 有効数字の考慮

    設定により、有効数字を考慮した計算が可能です（既定では無効です）。

* 単位換算

    数式の先頭に"[]"で括って単位を指定することで、計算結果を単位換算することが出来ます。  

    `[m/s] 42.195km / (2h + 25min)`

* 計算対象として一変数の方程式を指定すると、以下の要領で解を算出します。

    * 1～3次方程式に対しては代数的解法を用いて解きます。  

        `x^3 - 6x^2 + 11x - 6 = 0`

    * それ以外の方程式については、ニュートン法（式の微分に成功した場合）もしくはブレント法（式の微分に失敗した場合）を用いて、近似解を一つだけ求めます。  

        `x * sin(x) = 0.2`

その他、詳細な使用方法についてはClapteの[wiki](https://bitbucket.org/GoodSeat/clapte/wiki/Home)をご参照ください。

---
## 6. その他 ##

バグの報告、要望、質問などは以下までお願いいたします。

* 著作者           : いいせき
* Email            : GoodSeat@hotmail.co.jp
* HP               : https://sites.google.com/site/eatbaconandham/home
* バグや要望の報告 : https://bitbucket.org/GoodSeat/clapte/issues?status=new&status=open


---
## 7. 更新履歴 ##

#### 2024.03.17 ver2.2.0 ####
* 追加
    * 2進数、8進数、16進数による数値の表記を可能とした(接頭辞として0b/0o/0xを付けた数値を、2/8/16進数として認識)。
    * 2/8/10/16進数への変換関数(to0b/to0o/to0d/to0x)を追加した。
    * solve関数(解の公式を用いた求解)、solveN関数(ニュートン=ラフソン法を用いた求解)、solveB関数(ブレント法を用いた求解)を追加した。
    * 計算機に以下の機能を追加した。
        * 条件に応じて評価有無を切り替えるための制御文($if、$elif、$else、$endif)を利用可能に
        * 各行の入力/結果を格納したベクトル変数(\_inp、\_INP、\_ans、\_ANS)を利用可能に
        * 現在行を参照する変数(\_LN)を利用可能に
        * 入力ペインを外部のテキストファイルと同期する機能を追加
        * 結果ペインを外部のテキストファイルに自動出力する機能を追加
        * 選択行の総和を算出する機能を追加
* 修正
    * ユーザー定義関数を入れ子にした数式において、ユーザー定義関数が正しく計算されないことのある不具合を修正した。
    * "-1 cm" など、計算結果が単位を有する -1 となる場合に、"- cm"のように出力されてしまう不具合を修正した。
    * 常駐クリップボード計算において、"単位記号の認識方法"の設定に依らず、数式内に存在する単位名/変数名の文字列長が"単位として認識する最大文字列長"を超過する場合には計算対象外とするようにした。

#### 2021.01.24 ver2.1.5 ####
* 修正
    * 起動方法によって、設定ファイル等の読み込みや保存に失敗する不具合を修正した。

#### 2020.03.29 ver2.1.4 ####
* 追加
    * size関数（行列やベクトルの要素数を返す関数）を追加した。
    * 計算機に以下の機能を追加した。
        * 指定変数について整理
        * 選択部分に関する式に変形
    * 計算機における各種機能（単位換算や定義の抽出等）のインターフェイスを改善。
* 修正
    * 定義にユーザー定義関数を含むユーザー定義関数が正しく計算されない不具合を修正した。

#### 2019.09.20 ver2.1.3 ####
* 修正
    * 常駐クリップボード計算、計算機上の選択範囲の計算結果表示において、計算結果が単位を含む場合に計算結果が表示されない不具合を修正した。

#### 2019.09.14 ver2.1.2 ####
* 追加
    * 参照関数(ref)、@演算子を追加した。
* 修正
    * sigma関数、pi関数の除外変数条件が機能しない問題を修正した。
    * != 演算子が、不十分な情報から値を評価してしまうことのある問題を修正した。
    * ユーザー定義関数において、定義に使用した引数名と使用時に用いた引数名の関係に依って、正しく評価されないことがある問題を修正した。
    * 計算機において、演算子記号にシンタックスハイライトカラーが適用されない不具合を修正した。

#### 2019.08.17 ver2.1.1 ####
* 修正
    * cos(135°)及びcos(315°)が正しく計算されない問題を修正した。
    * ルートを含む計算で異常に時間が掛かることのある問題を修正した。

#### 2019.02.03 ver2.1.0 ####
* 追加
    * 計算機に以下の機能を追加した。
        * 数式の変形(展開、整理、因数分解)
        * 検索と置換
        * 計算過程の表示
        * 選択した部分のみの計算結果をポップアップ表示
        * ギリシャ文字の簡易入力機能
    * オンラインヘルプ機能を追加。
* 修正
    * 目標単位の分子及び分母に異なる接頭辞の同じ単位が存在する場合("[cm/m]")等のケースで、正しく単位換算されないことのある不具合を修正した。
    * 単位換算時、換算加算値が考慮されない不具合を修正した。
    * 計算機上でCtrl+ホイール操作でフォントサイズを変更した時に、他方のペインのフォントサイズが追従しない不具合を修正した。
    * 解が複数ある方程式で、一部の解が表示されないことのある不具合を修正した。
    * 数値精度を「任意精度」とした場合における計算精度を改善した。
    * その他、計算速度・安定性の向上、バグフィックス等。


#### 2017.01.16 ver2.0.1 ####
* 修正
    * 計算機における入力補助とヘルプ表示の不具合を修正した。
    * 計算機において、数式の構文解析エラーに対して赤い波線を表示し、ツールチップでその説明を表示するようにした。
    * Windows10において、タスクトレイのバルーン通知が適切なタイミングで表示されない不具合を修正した。

#### 2016.12.18 ver2.0.0 ####
* 追加
    * 計算機を刷新。
    * Clapteの多重起動時、計算機を表示するように修正。
    * 分数計算モードを追加。
    * 数値精度の選択機能を追加。
    * その他、計算速度・安定性の向上、バグフィックス等。

#### 2015.04.13 ver1.1.2 ####
* 追加
    * クリップボードの監視対象外とするアプリケーションを指定する機能を追加。

#### 2013.07.15 ver1.1.1 ####
* 修正
    * その解に虚数を含む2～3次方程式の計算処理時、落ちることのある不具合を修正。
    * 保存時、次の定数・単位の定義値が正しく保存されない不具合を修正。  
      Ttpw, oz, toz, lb, tf, pdl, at, BTU, statV
    * 定数、関数、単位変換表の編集で、Delキーで行を削除しても変更が反映されない不具合を修正。
   

#### 2013.06.29 ver1.1.0 ####
* 追加
    * 方程式の解の算出機能を追加。
    * 定型文コピーによる定数／関数定義機能を追加。
    * システム定義関数に、round、mod関数を追加。
    * 複素数の累乗計算の処理を追加。
 
* 修正
    * タスクトレイメニューの「有効」状態が正しく反映されない不具合を修正。
    * sin、log等の関数でも、有効数字を考慮して計算を行うよう修正。
    * `2sin(π)`等の数式で、省略された関数前の乗算を認識しない不具合を修正。
    * 既存変数と同名の引数を用いたユーザー定義関数の定義編集時に、落ちる不具合を修正。
    * 負数において、有効桁数が一桁少なく表示される不具合を修正。
    * 計算機における以下の不具合を修正。
        * 単語の色分け機能有効時、環境により、色分け処理時に画面がちらつく。
        * 単語の色分け機能有効時、元に戻すの機能が正しく働かない。
    * `5kg/(2cm*3mm)` 等、分母が同次元異接頭辞の乗算から成る数式の計算時、応答が無くなる不具合を修正。
    * 計算時、ユーザー定義定数の定義が数値に置き換わってしまう不具合を修正。


#### 2013.03.04 ver1.0.5 ####
* 修正
    * `(5+2)cm^2`等の数式で、省略されている乗算が、累乗より優先して解決されてしまう不具合を修正。


#### 2013.02.04 ver1.0.4 ####
* 修正
    * `1.0-((1.26683-0.7331615)*2.474/7.422)/2`等、計算時の約分で内部誤差の発生する特定条件の数式で、計算時にClapteの応答がなくなる不具合を修正。
    * `0.1^-20`等、内部誤差の発生する累乗の演算を含む数式の計算で、誤差が補正されない不具合を修正。
    * バージョン情報に表示されるビルド日時がでたらめなのを修正。


#### 2013.01.26 ver1.0.3 ####
* 修正
    * 一部の数式で、計算時に有効桁数が少なくなる不具合を修正。
    * 変換元の組立単位中に目標単位を含むケースで、単位変換が行われない不具合を修正。


#### 2013.01.24 ver1.0.2 ####
* 追加
    * 計算機上の入力数式に、文字区分に応じた色を付加する機能を追加。
    * 計算機から、関数・定数・単位の定義にジャンプする機能を追加。
    * 有効数字考慮時の端数処理のオプション（四捨五入/最近接偶数丸め）を追加。
    * 計算結果における単位表記のオプション（自動/空白で分割/"()"/"[]"）を追加。
 
* 修正
    * 単位換算表において一部単位の接頭辞の設定に誤りがあったのを修正。
    * `sin(45deg)-1/2^0.5`等、約分不可能な分数を含む数式の一部で、計算時に応答がなくなる不具合を修正。
    * `9.96 - 9.87`等の計算で発生する内部誤差を、補正して結果表示するよう修正。
    * 計算機において、特定条件で入力補助機能が表示されなくなる不具合を修正。
    * ()と{}の混在する数式で、計算が実行されないことのある不具合を修正。


#### 2013.01.07 ver1.0.1 ####
* 修正
    * 単位変換を伴う計算処理の速度を向上。
 
 
#### 2013.01.03 ver1.0.0 ####
